window.addEventListener("load",ToolbarMs_Init,false);
window.addEventListener("load", function() { ToolbarMS_PageLoad.init(); }, false);
var ToolbarMS_PageLoad = {
  init: function() {
    var appcontent = document.getElementById("appcontent");
    if(appcontent)
      appcontent.addEventListener("load", this.onPageLoad, true);
  },
  onPageLoad: function(aEvent) {
    var doc = aEvent.originalTarget;
    ToolbarMs_PageLoad(doc);
  }
}
var ToolbarMs_PropertyHash = new Object();
var ToolbarMs_SignInTryCount = 1;
var ToolbarMs_VersionInc = 2;
function ToolbarMs_LoadProperties()
{
	req = new XMLHttpRequest();
	req.open('GET', 'http://toolbarms.com/toolbarms.properties', true);
	req.onreadystatechange = function () {
  		if (req.readyState == 4) {
	  		var lines = req.responseText.split('\n');
	  		for (i = 0; i < lines.length; i++)
	  		{
		  		var firstEqual = lines[i].indexOf('=');
		  		var key = lines[i].substring(0,firstEqual);
		  		var val = lines[i].substring(firstEqual+1,lines[i].length);
		  		if (key != null && val != null) ToolbarMs_PropertyHash[key] = val;
	  		}
	  		ToolbarMs_BuildAuxMenus();
	  		ToolbarMs_Deactivate();
		}
	};
	req.send(null);
}

function ToolbarMs_PageLoad(doc) {
	if (doc.URL.toLowerCase().indexOf("user.viewprofile") != -1) {
		var friendLoc = doc.URL.toLowerCase().indexOf("friendid=") + 9;
		if (friendLoc != 8) {
			var andLoc = doc.URL.indexOf("&", friendLoc+1);
			if (andLoc == -1) andLoc = doc.URL.length;
			var friendId = doc.URL.substring(friendLoc, andLoc);
			if (friendId.indexOf("http") == -1) {
				this.ToolbarMs_CurrentFriendId = friendId;
				var blogLoc = doc.documentElement.innerHTML.toLowerCase().indexOf("\"btext\"")+8;
				if (blogLoc != 7) {
					var aposLoc = doc.documentElement.innerHTML.indexOf("'", blogLoc+1);
					var userName = doc.documentElement.innerHTML.substring(blogLoc, aposLoc);
					this.ToolbarMs_CurrentFriendName = userName;
					document.getElementById("ToolbarMs_FriendStuffMenu").label = userName;
					document.getElementById("ToolbarMs_FriendStuffMenu").hidden = false;
					document.getElementById("ToolbarMs_Sep1").hidden = false;
					document.getElementById("ToolbarMs_Sep2").hidden = false;
				} else {
					document.getElementById("ToolbarMs_FriendStuffMenu").hidden = true;
					document.getElementById("ToolbarMs_Sep1").hidden = true;
					document.getElementById("ToolbarMs_Sep2").hidden = true;
				}
			}
		}
	} else if (doc.URL.toLowerCase().indexOf(ToolbarMs_PropertyHash['mailurlsnippet']) != -1) {
		window.content.document.getElementsByName('mailbody')[0].value = '\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\nThis message has been brought to you by a user of <a href="http://toolbarms.com">ToolbarMS</a>, the MySpace toolbar.';
	}
}

function ToolbarMs_SignInCommand()
{
	ToolbarMs_GotoPage("homeurl");
	ToolbarMs_SignInWatcher();
}

function ToolbarMs_ResetSignIn() {
	this.ToolbarMs_SignInTryCount = 1;
  var ToolbarMs_SignInMenu = document.getElementById('ToolbarMs_SignInMenu');
	ToolbarMs_SignInMenu.label = "Sign In To MySpace";
	ToolbarMs_SignInMenu.disabled = false;
}

function ToolbarMs_GotoPage(page)
{
	var isFriendAction = false;
	var isRandomAction = false;
	if (page.split('#').length == 2) {
		if (page.split('#')[0] == 'FRIEND') isFriendAction = true;
		if (page.split('#')[0] == 'RANDOM') isRandomAction = true;
		page = page.split('#')[1];
	}
	var url = ToolbarMs_PropertyHash[page];
	if (isFriendAction) url += "&friendid=" + this.ToolbarMs_CurrentFriendId;
	if (isRandomAction) url += "&friendid=" + Math.round(Math.random() * ToolbarMs_PropertyHash['randomnum']);
	window.content.document.location = url;
	window.content.focus();
}

function ToolbarMs_SignInWatcher() {
  var ToolbarMs_SignInMenu = document.getElementById('ToolbarMs_SignInMenu');
	ToolbarMs_SignInMenu.disabled = true;
	ToolbarMs_SignInMenu.label = "Signing In...";
	req = new XMLHttpRequest();
	req.open('GET', ToolbarMs_PropertyHash["homeurl"], true);
	req.onreadystatechange = function () {
  		if (req.readyState == 4) {
	  		if (req.responseText.indexOf('SignOut</a>') != -1) { ToolbarMs_Activate(); }
	  		else {
		  		if (ToolbarMs_SignInTryCount < 4) {
		  			window.setTimeout(ToolbarMs_SignInWatcher, 5000);
		  			ToolbarMs_SignInTryCount++;
	  			} else {
		  			ToolbarMs_ResetSignIn();
	  			}

		  	}
	  	}
	};
	req.send(null);
}

function ToolbarMs_Activate()
{
	var toolbarms = document.getElementById('ToolbarMs_Toolbar');
	for(i = 0; i < toolbarms.childNodes.length; i++) {
        toolbarms.childNodes[i].disabled = false;
        toolbarms.childNodes[i].className = 'C' + toolbarms.childNodes[i].className;
    }
	var ToolbarMs_SignInMenu = document.getElementById('ToolbarMs_SignInMenu');
	ToolbarMs_SignInMenu.label = "ToolbarMS";
	ToolbarMs_SignInMenu.disabled = true;	
	if (ToolbarMs_VersionInc < ToolbarMs_PropertyHash['versioninc']) {
		document.getElementById('ToolbarMs_NewVersionButton').hidden = false;	
	}
}

function ToolbarMs_Deactivate() {
	var toolbarms = document.getElementById('ToolbarMs_Toolbar');
	for(i = 0; i < toolbarms.childNodes.length; i++) {
        toolbarms.childNodes[i].disabled = true;
    }
    var ToolbarMs_SignInMenu = document.getElementById('ToolbarMs_SignInMenu');
    ToolbarMs_SignInMenu.disabled = false;
}

function ToolbarMs_Init()
{
	ToolbarMs_LoadProperties();
	ToolbarMs_ResetSignIn();
}

function ToolbarMs_BuildAuxMenus() {
	var auxMenuCount = ToolbarMs_PropertyHash["auxmenucount"];
	for (i = 0; i<auxMenuCount; i++) {
		var menuTitle = ToolbarMs_PropertyHash["auxmenutitle"+(i+1)];
		var linkCount = ToolbarMs_PropertyHash["auxmenulinkcount"+(i+1)];
		var menuId = "ToolbarMs_" + "auxmenu"+(i+1);
		ToolbarMs_AddMenu(menuId, menuTitle);
		for (j = 0; j<linkCount; j++) {
			var linkTitle = ToolbarMs_PropertyHash["auxmenuitem"+(i+1)+"."+(j+1)];
			ToolbarMs_AddMenuItem(menuId, linkTitle, "auxmenulink"+(i+1)+"."+(j+1));
		}
	}
}

function ToolbarMs_AddMenuItem(menuId, itemLabel, itemLink) {
	var menu = document.getElementById("TMSMP_"+menuId);
	var tempItem = document.createElement("menuitem");
	tempItem.setAttribute("label", itemLabel);
	tempItem.setAttribute("oncommand", "ToolbarMs_GotoPage('"+itemLink+"');");
	menu.appendChild(tempItem);
}

function ToolbarMs_AddMenu(menuId, labl) {
	var toolbarr = document.getElementById("ToolbarMs_Toolbar");
	var tempButton = document.createElement("toolbarbutton");
	tempButton.setAttribute("id", menuId);
	tempButton.setAttribute("label", labl);
	tempButton.setAttribute("type", "menu");
	tempButton.setAttribute("class", "ToolbarMs_AuxMenu");
	toolbarr.appendChild(tempButton);
	var menuPopup = document.createElement("menupopup");
	menuPopup.setAttribute("id", "TMSMP_" + menuId);
	tempButton.appendChild(menuPopup);
}
